############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Zorp.py,v 1.27 2000/12/28 17:45:07 bazsi Exp $
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.8
## Notes:
##   - comments in English
##
############################################################################

"""Zorp module

This module

"""

# List of zones
zones = []

firewall_name = "zorp" # should be unique, proposed name format: zorp@domain

settings = {}          # configuration is stored in this hash


# return values returned by event handlers
Z_UNSPEC	 = 0
Z_ACCEPT	 = 1
Z_DENY		 = 2
Z_REJECT	 = 3

# log levels
Z_ERROR		 = 4
Z_CRITICAL 	 = 8
Z_WARNING 	 = 16
Z_MESSAGE 	 = 32
Z_INFO 		 = 64
Z_DEBUG          = 128

FALSE = 0
TRUE = 1

ZoneException = "Zone not found"
ServiceException = "Service"
DACException = "DAC policy violation"
MACException = "MAC policy violation"
AuthException = "Authenticated failed"
InternalError = "Internal error occured"


#def findZone(addr, interface = None):
#	"""Search for the zone of the given address/interface pair.
#
#	This function iterates on the zones array and looks for
#	the zone which contains addr.
#
#	Arguments:
#	
#	  addr       -- address to look up
#	  
#	  interface  -- interface
#	  
#	"""
#	i = 0
#        while (i < len(zones)):
#        	if (zones[i].isMember(addr, interface)):
#                	return zones[i]
#		i=i+1
#	raise ZoneException, "Zone for %s(%s) not found." % (addr.format(), interface)

def error(level, msg):
	"""Logs an error message

	Sends the given message to the low level Zorp provided
	log function.
		
	Arguments:

	  level	 -- log level
	  
	  msg    -- message

	Notes:
	
	  this function is obsolete and should not be used.
	"""
	log("core.error", level, msg)

def message(level, msg):
	"""Logs an informational message

	Sends the given message to the low level Zorp provided
	log function.

	Arguments:
	
	  level -- log level
	  
	  msg   -- message
	
	Notes:
	
	  this function is obsolete and should not be used.
	"""
	log("core.message", level, msg)

def debug(level, msg):
	"""Logs a debug message.

	Sends the given message to the low level Zorp provided
	log function.

	Arguments:
	
	  level  -- log level
	  
	  msg    -- message
	  
	Notes:
	
	  this function is obsolete and should not be used.
	"""
	log("core.debug", level, msg)
	
def init(name):
	"""Default init() function provided by Zorp
	
	This function is a default init() calling the init function
	identified by name. This way several Zorp instances can easily
	use the same policy file.

	Arguments:
	
	  name -- name of this instance
	"""
	import __main__
	func = getattr(__main__, name)
	func()

		
def log(logclass, verbosity, msg):
	"""Entry point of Zorp logging subsystem.
	
	This function is implemented in C, and can be used to inject
	messages into Zorp logging subsystem.

	Arguments:

	  logclass -- hierarchical log class as described in zorp(8)
	  
	  verbosity -- verbosity of this message

	  msg -- message
	"""
	pass

class ZorpProxy:
	"""Builtin interface for proxies implemented in C.
	
	Builtin class for proxies implemented as an ExtensionClass in C
	
	This class should not be used directly, derive classes
	from Proxy.Proxy.
	  
	"""
	def __init__(self, name, session_id, client_stream):
		"""Initialize a low level proxy instance.

		This function is implemented in C, and is responsible
		of loading the needed proxy module from a shared object
		if it has not yet been loaded, and starting a new
		instance with parameters passed here.
		
		Arguments:

		  self          -- this instance
		
		  name          -- proxy module name (`http', `plug' etc.)
		  
		  session_id    -- session id to use in log messages
		  
		  client_stream -- client stream
		  
		"""
		pass
